var url = 'status.html';

var deleteTrackNum = null;
var thisTrack;
var thatTrack;

var scrollHeight = 320;
var songcount = 0;
var blockAjaxGetRows = false;

var _progressEnd = (_progressEnd) ? _progressEnd : 8;
var _progressAt = (_progressAt) ? _progressAt : 0;
var _progressBarWidth = 156;
var _volumeBarWidth = 262;
var p = 1;
var inc = 0;
var intervalID = false;
var incr;
var overlaysON = false;
var coverON = true;
var storeOverlays = false;
var streamType = 0;		// 0: none; 1: song; 2: stream
var songtitleid = 0;

var args = 'player='+player+'&ajaxRequest=1';


// Update the progress dialog with the current state
function refreshProgressBar(theData) {
	var parsedData = fillDataHash(theData);
	var elements = [ 'duration', 'elapsed' ];
	elements.each(function(key) {
		if ($(key)) {
			if (parsedData[key]) {
				refreshElement(key, parsedData[key]);
			}
		}
	});
	_progressAt = parseInt(parsedData['songtime'], 10);
	_progressEnd = parseInt(parsedData['durationseconds'], 10);
	setProgressBarWidth();
	if (!intervalID) {
		progressUpdate();
	}
}

function progressUpdate() {
	// player is playing, therefore run this function again in 1 second
	if ($('playercontrol_active_play').style.display == 'block') {
		_progressAt++;
		setProgressBarWidth();
	 	if (!intervalID) {
			intervalID = setInterval("progressUpdate()", 1000);
		}
	// do run progressUpdate every 5s (50s full)if the player is not playing
	} else {
	//	inc = 0;
		if (!intervalID)
			intervalID = setInterval("progressUpdate()", 5000);
	}
	inc++;
	
	// do an ajax update every 10 seconds while playing
	if (inc == 10) {
		getStatusData(args, refreshAll);
		inc = 0;
	}
//	else
//	{
//		getStatusData (args, refreshSome);
//	}
}

function setProgressBarWidth() {
	if ( _progressAt >= _progressEnd) {
		_progressAt = _progressEnd;
		clearIntervalCall();
		doRefresh();
	}
	if (_progressAt < 0) _progressAt  = 0;
	var p = parseInt (( _progressBarWidth * _progressAt) / _progressEnd);
	var s = _progressAt % 60;
	if (s < 10) { s = "0" + s; }
	refreshElement("elapsed", parseInt(_progressAt / 60, 10) + ":" + s);
	$("progressBar").style.width=p;
	$("progressButton").style.left=parseInt(p + 34);
}

function resetProgressBar() {
	if ($('progressBar')) {
		$('progressBar').style.width=0;
		$("progressButton").style.left=34;
		_progressAt = 0;
		clearIntervalCall();
	}
}


function toggleOverlays() {
	var theDivs = [ 'iNowWrapperBottom', 'iNowWrapperTop' ]; // , 'iNowOverlayBottom'
//	if ((streamType == 1) || overlaysON) theDivs.push ( 'iNowWrapperTop' ); //'iNowOverlayTop', 
	if (overlaysON) {
		overlaysON = false;
		hideElements(theDivs);
	} else {
		overlaysON = true;
		showElements(theDivs);
	}
}


function toggleCover() {
	var sWidth = 320;
	if (coverON) {
	 	coverON = false;
		$("playlistNow").style.display = "block";
		$('coverToggleButton').style.display = 'none';
		$('coverToggleArtwork').style.display = 'block';
		if (overlaysON) {
			toggleOverlays();
			storeOverlays = true;
		} else {
			storeOverlays = false;
		}
	} else {
		coverON = true;
		$('coverToggleButton').style.display = 'block';
		$('coverToggleArtwork').style.display = 'none';
	}
	
	scrollCover();
	var timer = setInterval (scrollCover, 0);
	
	function scrollCover() {
	 	if (sWidth > 64) {
			sWidth = sWidth - 64;
		} else {
			clearInterval(timer);
			sWidth = 0;
			if (coverON) {
		// 		$("playlistNow").style.display = "none"; keep it on to remember scroll position;
				if (storeOverlays) toggleOverlays();
			}
		}
		var cover;
		switch (streamType) {
			case 1: cover = $("coverart"); break;
			case 2: cover = $("radioart"); break;
			default: 
				clearInterval(timer);
				sWidth = 0;
				return;
		}
		if (coverON) {
			cover.style.left = -sWidth;
		} else {
			cover.style.left = sWidth - 320;
		}
	}
}


// parses the data if it has not been done already - need the first one for my AJAX calls don't want to fiddle with divs there...
function fillDataHashPure(theData) {
	var returnData = null;
	if (theData['player_id']) { 
		return theData;
	} else {
		var myData = theData.responseText;
		returnData = parseData(myData);
	}
	return returnData;
}

function fillDataHash(theData) {
	var returnData = null;
	if (theData['player_id']) { 
		return theData;
	} else {
		var myData = theData.responseText;
		returnData = parseData(myData);
	}

	// make the correct divs be shown; this is a good spot for this because fillDataHash is called first by all refreshFunctions()
	var hideDivs;
	var showDivs;
	// radio
	if (returnData['streamtitle']) {
		showDivs = [ 'radioart', 'streaminfo', 'playlistNow' ];
		hideDivs = [ 'songinfo', 'coverart', 'emptyplayer' ];
		streamType = 2;
	// track
	} else if (returnData['songcount'] > 0) {
		hideDivs = [ 'radioart', 'streaminfo', 'emptyplayer'  ];
		showDivs = [ 'songinfo', 'coverart', 'playlistNow' ];
		streamType = 1;
	// empty playlist
	} else {
		showDivs = [ 'emptyplayer', 'playlistNow' ];
		hideDivs = [ 'songinfo', 'coverart', 'radioart', 'streaminfo'];
		streamType = 0;
	}
	if (overlaysON) {
		showDivs.push ( 'iNowWrapperBottom', 'iNowWrapperTop' );
	} else {
		hideDivs.push ( 'iNowWrapperBottom', 'iNowWrapperTop' );
	}
	hideElements(hideDivs);
	showElements(showDivs);
	return returnData;
}

function refreshSome(theData) {
//	clearIntervalCall();
	var parsedData = fillDataHash(theData);
	refreshControls(parsedData);
//	refreshOtherElements(parsedData);
	refreshProgressBar(parsedData);
}

function refreshAll(theData) {
	inc = 0;
	// stop progress bar refreshing for this track
	clearIntervalCall();
	var parsedData = fillDataHash(theData);
	refreshControls(parsedData);
	refreshOtherElements(parsedData);
	refreshProgressBar(parsedData);
}

function refreshControls(theData) {

	var parsedData = fillDataHash(theData);
	// refresh control_display in songinfo section
	refreshPlayerStatus(parsedData);

	// refresh player controls
	var selected=null;
	if (parsedData['playmode'] == 0) {
//		selected = 'stop';
		selected = 'pause';
	} else if (parsedData['playmode'] == 1) {
		selected = 'play';
	} else if (parsedData['playmode'] == 2) {
		selected = 'pause';
	}
	playerButtonControl('player', selected, '', true);
	
	//if (parsedData['sleep']) Element.show('statustimer'); else Element.hide('statustimer'); //How do I get this info????
	
	setPowerControl(parsedData['mode']);
	refreshVolumeControl(parsedData);
}

function refreshTrackStat(tracknum) {
 	if (streamType != 1)
		$('iNowWrapperTop').style.height = '48'; 	
	var sArray = [ 'trackstat', 'getrating', tracknum ];
	callJSONRPC(sArray, function (r2) {
	 		doRefreshTS (r2.result.rating);
		}, function (r2) {});
}

function doRefreshTS(refnum) {
	$('iNowWrapperTop').style.height = '88';
 	if ($('trackstat_star1'))
		for (num = 1; num < 6; num++) {
			if (refnum >= num)
				$('trackstat_star' + num).src = webroot + 'html/images/fullstar.png';
			else
				$('trackstat_star' + num).src = webroot + 'html/images/nostar.png';
		}
}

function setTrackStat(num) {
	if (songtitleid) {
		var sArray = [ 'trackstat', 'getrating', songtitleid ];
		callJSONRPC(sArray, function (r2) {
		 	if ((num == 1) && (r2.result.rating == 1))
		 			num = 0;
			var sArray2 = [ 'trackstat', 'setrating', songtitleid, num ];
				callJSONRPC(sArray2, function (r3) { 
				 	doRefreshTS(r3.result.rating); }, function (r3) {});
		}, function (r2) {});
	}
}

function setPowerControl(mode) {
	if (mode == 'on') {
		Element.hide('powerControlOff');
		Element.show('powerControlOn');
	} else {
		Element.hide('powerControlOn');
		Element.show('powerControlOff');
	}
}

function setVolume(evt) {
	var level = parseInt((evt.clientX - 29) * 100 / _volumeBarWidth);
	if (level < 0) level = 0;
	if (level > 100) level = 100;
	volumeControl(level);
}

function setTrackTime(evt) {
	var level = parseInt((evt.clientX - 82) * _progressEnd / _progressBarWidth);
	if (level < 0) level = 0;
	if (level > _progressEnd) level = _progressEnd;
	var pArray = [ "time", level];
	callJSONRPC (pArray, function (r2) { getStatusData("player=" + player + "&ajaxRequest=1", refreshAll); });	// worst of all hacks, tbe
}

function refreshVolumeControl (theData) {
	var parsedData = fillDataHash(theData);
	var intVolume = parseInt(parsedData['volume']);
	var intPos = parseInt((intVolume * _volumeBarWidth) / 100);
	
	$("volumeBar").style.width=intPos;
	$("volumeButton").style.left=intPos;
}

function refreshPlayerStatus(theData) {
	var parsedData = fillDataHash(theData);
	var controls = ['thissongnum', 'songcount'];//'playtextmode', 
	songcount = parsedData['songcount'];
	controls.each(function(key) {
		if ($(key)) {
			refreshElement(key, parsedData[key]);
		}
	});
	if (!intervalID) {
		progressUpdate();
	}
}

function volumeControl(level) {
	var param = 'p0=mixer&p1=volume&p2='+level+'&player=' + player + '&ajaxRequest=1';
	getStatusData(param,refreshVolumeControl);
}

// called from onClick on repeat or shuffle controls
function playerButtonControl(playerRepeatOrShuffle, selected, param, noRequest) {
	// make the image selected 'active'
	// make the rest not active
	var controls = ['off', 'song', 'album', 'playlist', 'play', 'pause', 'stop'];
	var turnOn = null;
	var turnOff = null;
	controls.each(function(thisControl) {
		if (thisControl == selected) {
			turnOn = playerRepeatOrShuffle+'control_active_'+thisControl;
			turnOff = playerRepeatOrShuffle+'control_'+thisControl;
		} else {
			turnOn = playerRepeatOrShuffle+'control_'+thisControl;
			turnOff = playerRepeatOrShuffle+'control_active_'+thisControl;
		}
		if ($(turnOff)) {
			Element.hide(turnOff);
		}
		if ($(turnOn)) {
			// still haven't figured this out, but prototype's Element.show here kills the progress bar. Bizarre
			//Element.show(turnOn);
			// go with this instead
			document.getElementById(turnOn).style.display = "block";
		}
	});
	if (selected == 'stop') {
		resetProgressBar();
	}
	if (noRequest) {
		return true;
	} else if (selected == 'prev') {
//		$('playercontrol_prev').src = 'html/images/larger/prev.gif';
		if (_progressAt > 10) {
			var r_param = 'p0=playlist&p1=jump&p2=-0&'+param;
			getStatusData(r_param, refreshAll);
		} else {
			var r_param = 'p0=playlist&p1=jump&p2=-1&'+param;
			getStatusData(r_param, refreshAll);
		}
	} else if (selected == 'next') {
//		$('playercontrol_next').src = 'html/images/larger/next.gif';
		getStatusData(param, refreshAll);
	} else if (playerRepeatOrShuffle == 'player') {
		getStatusData(param, refreshAll);
	} else if (playerRepeatOrShuffle == 'shuffle') {
		getStatusData(param, refreshAll);
	} else {
		getStatusData(param, refreshNothing);
	}
}

// called from onClick on play/pause/stop/prev/next controls
function playerControl(selected, param) {
	// make the image selected 'active'
	// make the rest not active
	var imgStub = 'html/images/larger/';
	var controls = ['pause', 'stop']; //'play'
	controls.each(function(thisControl) {
		var imgSrc = null;
/*		if (thisControl == selected) {
			imgSrc = imgStub + thisControl + '_active.gif';
		} else {
			imgSrc = imgStub + thisControl + '.gif';
		}*/
		var key = 'playercontrol_'+thisControl;
		if ($(key)) {
			$(key).src = imgSrc;
		}
	});
}

function refreshAlarm() {
	var sArray = [ 'alarms', '0', '8', 'filter:enabled' ];
	callJSONRPC(sArray, function (r2) {
	 		if (r2.result.count > 0)
	 			Element.show('statusalarm');
	 		else
	 			Element.hide('statusalarm');
		}, function (r2) {});
}


// NO LINKS IN HERE, THIS IS IPHONE!, KEEP THE WORLD SIMPLE!

function refreshOtherElements(theData) {
	var parsedData = fillDataHash(theData);
	// refresh cover art
	if ($('coverartpath')) {
		var coverPath = null;
		if (parsedData['coverartpath'].match('cover') || parsedData['coverartpath'].match('radio') || parsedData['coverartpath'].match('icon\.png')) {
			coverPath = parsedData['coverartpath'];
		} else if (parsedData['coverartpath'].match('^http:/')) {
			coverPath = parsedData['coverartpath'];
		} else {
			coverPath = '/music/'+parsedData['coverartpath']+ '/cover.jpg';   //'/thumb_190x190_p.jpg';
		}
		$('radioartpath').src = coverPath;
		$('coverartpath').src = coverPath;
		$('coverToggleArtwork').src = coverPath;
	}

	// refresh song info
	var songinfoArray = [ 'songtitle', 'artist',  'album', 'streamtitle' ];
	songinfoArray.each(function(key) {
		if (parsedData[key])
			refreshElement(key, parsedData[key], 30);
	});
	
	// refresh trackstat
	songtitleid = parseInt(parsedData['songtitleid']);
	if ($('trackstat_star1'))
		refreshTrackStat(songtitleid);
	
	// refresh timer
	if (parsedData['sleeptime'] > 0) {
		Element.show('statustimer');
	} else {
		Element.hide('statustimer');
	}
	refreshAlarm();
	
	refreshPlaylist(theData);
}


// Playlist functions go here

function refreshPlaylist(theData) {
	var parsedData = fillDataHashPure(theData);
	var thetable =  document.getElementById('playlisttableNow');
	var first = parseInt(parsedData['first_item']);
	var last = parseInt(parsedData['last_item']);
	var num;
	var thisrow;
	var newcount = parseInt(parseData('playlistsize'));
	var playing = parsedData['thissongnum'] - 1;
	for (num = first; (num <= last) || (!num && !last); num++) {
		thisrow = document.getElementById('row' + num);
		if (!thisrow) {
			if (num > 0) insertLineRow (thetable, null, num);
		 	insertDataRow (thetable, null, num, parsedData['item_' + num], parsedData['title_' + num], parsedData['duration_' + num], (playing == num));
		} else if (thisrow.getAttribute('item') != parsedData['item_' + num]) {
//			var newtable = thetable.cloneNode(false); // mobile Safari does not like this :-(
			var i;
			for (i = first; (i <= last) || (!i && !last); i++) {
				if (i > 0) insertLineRow (thetable, null, i);
			 	insertDataRow (thetable, null, i, parsedData['item_' + i], parsedData['title_' + i], parsedData['duration_' + i], (playing == i));
			}
			thetable.deleteRow(0);
			while (thetable.rows[0].id != 'row' + first) // not elegant, but... works
				thetable.deleteRow(0);
			
//			thetable.parentNode.replaceChild(newtable, thetable);
//			delete thetable; // how the hell do I delete an Element??????
			return;
		}
	}
	num = songcount * 2 -  1;
	while (thetable.rows.length > num)	// not elegant... better ideas?
		thetable.deleteRow(thetable.rows.length - 1);
	doPlay(parsedData);
}

function playNow(num) {
	getStatusData("p0=playlist&p1=jump&p2=" + num + "&player=" + player + "&ajaxRequest=1" , doPlay);
}

function doPlay(theData) {
	var parsedData = fillDataHashPure(theData);
	var i;
	var playing = parsedData['thissongnum'] - 1; // strange, thissongnum seems to be not 0-based...
	var thetable =  document.getElementById('playlisttableNow');
	for (i = 0; i < thetable.rows.length; i++) {
		if (thetable.rows[i].hasAttribute('playing'))
			if (thetable.rows[i].id != ('row' + playing))
				updateCurrentRow (parseInt(thetable.rows[i].id.slice(3)), false);
	}
	updateCurrentRow (playing, true);
}

function deleteNow(num) {
	thisTrack = num;
	var oldurl = url;
 	url = webroot + 'playlist.html';
	var param = 'p0=playlist&p1=delete&p2=' + num + '&player=' + player + '&ajaxRequest=1';
	getStatusData(param, doDelete);
	url = oldurl;
}

function doDelete(theData) {
 	var num = thisTrack;
	for (i = num; i < (songcount - 1); i++)	{
		swapRows (i + 1, i != num);
	}
	var thetable =  document.getElementById('playlisttableNow');
	thetable.deleteRow(thetable.rows.length - 1);
	if (num > 0) thetable.deleteRow(thetable.rows.length - 1);
}

function swapNow(num) {
	if (num < 1) return;
	thisTrack = num;
	var oldurl = url;
 	url = webroot + 'playlist.html';
	var param = 'p0=playlist&p1=move&p2=' + num + '&p3=-1&player=' + player + '&ajaxRequest=1';
	getStatusData(param, doSwap);
	url = oldurl;
}

function doSwap(theData) {
	swapRows(thisTrack, true);
}

function swapRows(num, updateCurrent) {
 	if ((num <= 0) || (num >= songcount)) return;
	var item =  document.getElementById('row' + num);
	var xitem = document.getElementById('row' + (num - 1));
	var temp = item.getAttribute('item');
	item.setAttribute('item', xitem.getAttribute('item'));
	xitem.setAttribute('item', temp);
	if (item.hasAttribute('playing')) {
		updateCurrentRow(num, false);
		updateCurrentRow(num - 1, true);
	} else if (xitem.hasAttribute('playing') && updateCurrent) {
		updateCurrentRow(num, true);
		updateCurrentRow(num - 1, false);
	}
	var fields = ['rlink', 'rduration'];
	fields.each(function(key) {
		item = document.getElementById(key + num);
		xitem = document.getElementById(key + (num - 1));
		temp = item.innerHTML;
		item.innerHTML = xitem.innerHTML;
		xitem.innerHTML = temp;
	});
}

function mousewheelNow(evt) {
 	var scrollWindow = document.getElementById('playlistNow');
 	var thetable = document.getElementById('playlisttableNow');
 	var therow = null;
 	var param = null;
 	
 	if (blockAjaxGetRows) return;	// do not repeat this to extremes
	if ((evt.wheelDelta < 0) && ((scrollWindow.scrollHeight - scrollWindow.scrollTop - scrollHeight) < 80)) {
	 	var lastPresent = 0;
 	 	if (thetable.rows.length > 0) {
	 		therow = thetable.rows[thetable.rows.length - 1];
			var tIndex = thetable.rows.length - 1;
			while ((tIndex > 0) && (therow.id.indexOf ("row") == -1)) {
				tIndex --;
				therow = thetable.rows[tIndex];
			}
 	 	 	if (therow.id.indexOf("row") != -1) 
			  	lastPresent = parseInt (therow.id.slice(3));
	 		if ((lastPresent + 1) >= songcount) return;	// nothing to do!
	 	}
	 	var oldurl = url;
	 	url = webroot + 'playlist.html';
	 	param = '?start=' + (lastPresent + 1) + "&player=" + player + '&ajaxRequest=1';
	 	blockAjaxGetRows = true; // only once;
		getStatusData(param, addRowsNow);
		url = oldurl;
	} else if ((evt.wheelDelta > 0) && (scrollWindow.scrollTop < 80)) {
	 	var firstPresent = 0;
		if (thetable.rows.length > 0) {
	 		therow = thetable.rows[0];
			var tIndex = 0;
			while ((tIndex < (thetable.rows.length - 1)) && (therow.id.indexOf ("row") == -1)) {
				tIndex ++;
				therow = thetable.rows[tIndex];
			}
 	 	 	if (therow.id.indexOf("row") != -1) 
			  	firstPresent = parseInt (therow.id.slice(3));
	 		if (firstPresent <= 0) return;	// nothing to do!
	 	}
	 	var oldurl = url;
	 	url = webroot + 'playlist.html';	// use playlist.html...dunno why I do this, status support's it too...
	 	firstPresent = firstPresent - 20;	//arbitrary...
	 	if (firstPresent < 0) firstPresent = 0;
	 	param = '?start=' + firstPresent + "&player=" + player + '&ajaxRequest=1';
	 	blockAjaxGetRows = true; // only once;
		getStatusData(param, addRowsNow);
		url = oldurl;
	}
}

function addRowsNow (theData) {
	var parsedData = fillDataHashPure(theData);
	var fi = parseInt(parsedData ['first_item']);
	var li = parseInt(parsedData ['last_item']);
	console.log('aj:fi ' + fi + 'li ' + li);
 	var thetable = document.getElementById('playlisttableNow');
 	
	var tIndex = thetable.rows.length - 1;
	var therow = thetable.rows[tIndex];
	while ((tIndex > 0) && (therow.id.indexOf ("row") == -1)) {
		tIndex --;
		therow = thetable.rows[tIndex];
	}
	if (therow.id.substr (0,3) != "row") return;
 	var oldLast = parseInt(therow.id.slice(3));
 	
 	tIndex = 0;
 	therow = thetable.rows[0];
 	while ((tIndex < thetable.rows.length) && (therow.id.indexOf ("row") == -1)) {
		tIndex ++;
		therow = thetable.rows[tIndex];
	}
	if (therow.id.substr (0,3) != "row") return;
 	var oldFirst = parseInt(therow.id.slice(3));
	var playing = parsedData['thissongnum'];
	
	if (fi > oldLast) {
	 	var i;
		for (i = fi; i <= li; i++) {
		 	insertLineRow (thetable, null, i);
		 	therow = insertDataRow (thetable, null, i, parsedData['item_' + i], parsedData['title_' + i], parsedData['duration_' + i], (playing == i));
		}
		document.getElementById('playlistNow').scrollTop += 40;
	} else if (fi < oldFirst) {
	 	var i;
	 	if (tIndex > 0) therow = thetable.rows[tIndex - 1];
	 	for (i = oldFirst - 1; i >= fi ; i--) {
			therow = insertDataRow (thetable, therow, i, parsedData['item_' + i], parsedData['title_' + i], parsedData['duration_' + i], (playing == i));
			if (i > 0) 
				therow = insertLineRow (thetable, therow, i);
//			else												// not yet...
//				therow = insertDummyRow (thetable, therow);
		}
		document.getElementById('playlistNow').scrollTop = (oldFirst - fi - 1) * 40 + 8;
	}
	blockAjaxGetRows = false;
//	getStatusData(args, refreshAll);
}

function insertDummyRow (thetable, nrow) {
	var newrow = document.createElement("tr");
	newrow.setAttribute('class', 'even');
	newrow.style.borderBottom = '1px solid #333333';
	newrow.style.height = 44;
	newrow.innerHTML = "<td colspan = \'4\'>" +
						"<img style = \'height: 44;\' src = \'" + webroot + "html/images/between_line_trans.png\'>" +
						"</td>";
	var rtemp = thetable.rows[0];
	rtemp.parentNode.insertBefore(newrow, nrow);
	return newrow;
}


function insertLineRow (thetable, nrow, num) {
	//var newrow = thetable.insertRow (idx); // does not work, Safari collapses Table height on insert
	var newrow = document.createElement("tr");
	
	newrow.setAttribute('class', 'xchgLine');
	newrow.style.height = 1;
	
	newrow.innerHTML = "<td colspan = \'4\'>" +
							"<div style = \'position: absolute;\'>" +
								"<a href=\'javascript:swapNow(" + num + ");\' style = \'position: absolute; display: block; width: 100%; margin: -5; padding: 5\'>" +
								"<img style = \'width: 320; height: 1;\' src = \'" + webroot + "html/images/between_line.png\'>" +
								"<img style = \'position: relative; top: -6; left: 38; z-index: 1; padding: 0;\' src = \'" + webroot + "html/images/between2.png\'>" +
							"</div></a>" +				// a/div order intentionally wrong!!!!
						"</td>";
	var rtemp = thetable.rows[0];
	rtemp.parentNode.insertBefore(newrow, nrow);
	return newrow;
}

function insertDataRow (thetable, nrow, inum, iitem, ititle, iduration, current) {
//	var newrow = thetable.insertRow (idx);  // does not work, Safari collapses Table height on insert
//alert('insertDataRow' + thetable + '.' + nrow + '.' + inum + '.' + iitem + '.' + ititle + '.' + iduration + '.' + current)
	var newrow = document.createElement("tr");
	var stitle = null;
	newrow.id = 'row' + inum;
	if (current) 
		newrow.setAttribute('class', 'selectedRow');
	else newrow.setAttribute('class', (inum % 2) ? 'odd' : 'even');
	newrow.style.height = 38;
	newrow.setAttribute('item', iitem);
	if (current) newrow.setAttribute ('playing', 'true');
		
	if (ititle.length > 40)
		stitle = ititle.substring(0,37) + '...';
	else
		stitle = ititle;
	newrow.innerHTML =	"<td style = \'width: 30; padding-left: 4;\'>" + (inum + 1) + "</td>" +
						"<td id = \'rtitle" + inum +"\' style = \'" + (current ? "" : "border-left: 1px solid #333333;") + 
							"padding-left: 4; padding-right: 4\'>" +
							"<a id = \'rlink" + inum + "\' href=\"javascript:playNow(" + inum + ");\" style = \'display: block; width: 100%; margin: 4; color: white;\'>" + stitle + 
							"</a></td>" +
						"<td id = \'rremove" + inum + "\' style = \'padding-right: 4\'><img src = \'" + webroot + "html/images/x_" + (current ? "blue_none" : "grey") + ".png\' onClick = \'deleteNow(" + inum + ");\'></td>" +
						"<td id = \'rduration" + inum + "\' style = \'" + (current ? "" : "border-left: 1px solid #333333; ") + "padding-right: 2; width: 40;\' align = \'right\'>" + iduration + "</td>";

	if (thetable.rows[0]) {	//hasChildNodes()
		var rtemp = thetable.rows[0];
		rtemp.parentNode.insertBefore(newrow, nrow);
	} else 
		thetable.appendChild(newrow);
		
	if (current)
		newrow.scrollIntoView(true);
	return newrow;
}

function updateCurrentRow(num, iscurrent) {
 	var item = document.getElementById('row' + num);
	if (item == null) return;
	if (iscurrent) {
//	 	$('playlistNow').scrollTop = item.offsetTop;
		if (item.hasAttribute('playing')) return;
		item.scrollIntoView(true);
		item.setAttribute('playing', 'true');
		item.setAttribute('class', 'selectedRow');
		document.getElementById('rtitle' + num).style.borderLeft = 0;
		item = document.getElementById('rremove' + num);
		item.innerHTML = "<img src = \'" + webroot + "html/images/x_blue_none.png\'>";
		document.getElementById('rduration' + num).style.borderLeft = 0;
	} else {
		if (!item.hasAttribute('playing')) return;
		item.removeAttribute('playing');
		item.setAttribute('class', (num % 2 ? 'odd' : 'even'));
		document.getElementById('rtitle' + num).style.borderLeft = '1px solid #333333';
		item = document.getElementById('rremove' + num);
		item.innerHTML = "<img src = \'" + webroot + "html/images/x_grey.png\'>";
		document.getElementById('rduration' + num).style.borderLeft = '1px solid #333333';
	}
}


window.onload= function() {
	getStatusData(args, refreshAll);
	progressUpdate();
	globalOnload();
 	scrollTo (0,1);
}





